/// <reference path="../../reference/cristalix.d.ts" />
import { AnimationFinisher, Task } from './api';
import { AbstractElement } from './elements';
export declare type ScreenState = {
    scaleFactor: number;
    screenWidth: number;
    screenHeight: number;
    unicodeFlag: boolean;
};
export declare class Animation {
    readonly element: AbstractElement;
    readonly propertyId: number;
    startedTime: number;
    duration: number;
    startValue: number;
    targetValue: number;
    easingId: number;
    lastValue: number;
    onFinish: AnimationFinisher;
    constructor(element: AbstractElement, propertyId: number);
    newTarget(value: number, duration: number, easingId: number, onFinish?: AnimationFinisher): void;
    update(time: number): boolean;
}
export declare var runningTasks: Task[];
export declare var runningAnimations: Animation[];
export declare function getScreenState(): ScreenState;
export declare var lastScreenState: ScreenState;
export declare const overlayLegacy: AbstractElement[];
