/// <reference path="../../reference/cristalix.d.ts" />
// Positive numbers are matrices that are directly converted to GL transformations
export var alignMatrix = 0;
export var rotationMatrix = 1;
export var offsetMatrix = 2;
export var scaleMatrix = 3;
export var originMatrix = 4;
// Amount of direct GL matrices for preallocations
export var matrixFields = 5;
// Negative numbers are markers for non-gl properties updates to smh influence the gl matrices
// Examples of marker sizeMatrix being used:
// to update autoFit scale when text content changes; 
// to update align matrices of rect's children when its width/height changes
export var sizeMatrix = -1;
export var colorMatrix = -2;
export var uvMatrix = -3;
export var allMatrices = [alignMatrix, rotationMatrix, offsetMatrix, scaleMatrix, originMatrix, sizeMatrix, colorMatrix, uvMatrix];
export var matrixInfluence = [];
export var offsetX = 0;
matrixInfluence.push([offsetMatrix]);
export var offsetY = 1;
matrixInfluence.push([offsetMatrix]);
export var offsetZ = 2;
matrixInfluence.push([offsetMatrix]);
export var scaleX = 3;
matrixInfluence.push([scaleMatrix]);
export var scaleY = 4;
matrixInfluence.push([scaleMatrix]);
export var scaleZ = 5;
matrixInfluence.push([scaleMatrix]);
export var alignX = 6;
matrixInfluence.push([alignMatrix]);
export var alignY = 7;
matrixInfluence.push([alignMatrix]);
export var alignZ = 8;
matrixInfluence.push([alignMatrix]);
export var originX = 9;
matrixInfluence.push([originMatrix]);
export var originY = 10;
matrixInfluence.push([originMatrix]);
export var originZ = 11;
matrixInfluence.push([originMatrix]);
export var rotationX = 12;
matrixInfluence.push([rotationMatrix]);
export var rotationY = 13;
matrixInfluence.push([rotationMatrix]);
export var rotationZ = 14;
matrixInfluence.push([rotationMatrix]);
export var rotationAngle = 15;
matrixInfluence.push([rotationMatrix]);
export var colorA = 16;
matrixInfluence.push([colorMatrix]);
export var colorR = 17;
matrixInfluence.push([colorMatrix]);
export var colorG = 18;
matrixInfluence.push([colorMatrix]);
export var colorB = 19;
matrixInfluence.push([colorMatrix]);
export var parentSizeX = 20;
matrixInfluence.push([alignMatrix]);
export var parentSizeY = 21;
matrixInfluence.push([alignMatrix]);
export var parentSizeZ = 22;
matrixInfluence.push([alignMatrix]);
export var sizeX = 23;
matrixInfluence.push([sizeMatrix, originMatrix]);
export var sizeY = 24;
matrixInfluence.push([sizeMatrix, originMatrix]);
export var sizeZ = 25;
matrixInfluence.push([sizeMatrix, originMatrix]);
export var textureX = 26;
matrixInfluence.push([uvMatrix]);
export var textureY = 27;
matrixInfluence.push([uvMatrix]);
export var textureWidth = 28;
matrixInfluence.push([uvMatrix]);
export var textureHeight = 29;
matrixInfluence.push([uvMatrix]);
export var valueFields = 30;
export var leftMouseButton = 0;
export var rightMouseButton = 1;
export var middleMouseButton = 2;
